﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WLG.Controller;
using WLG.Model.Interface;
using WLG.Model;

namespace WLG.ViewFixture
{
    /// <summary>
    /// Interaction logic for PageDefault.xaml
    /// </summary>
    public partial class PageDefault : Page
    {
        IApplicationModelController controller = new ApplicationModelController();

        public PageDefault()
        {
            InitializeComponent();

            IAuthenticationProvider authProvider = new WLG.AuthenticationProvider.WindowsLiveAuthenticationProvider();
            IApplicationModelView DefaultView = new WLG.WPFView.ApplicationModelView();
            INotifyDataProvider notifyProvider = new WLG.NotifyLiveDataProvider.SocialFeed.LiveSocialDataProvider();
            IApplicationModel model = new ApplicationModel();

            controller.SetModel(model);
            controller.AddView(DefaultView);
            controller.SetAuthenticationProvider(authProvider);
            controller.SetNotifyDataProvider(notifyProvider);

            // Bind to view
            this.LayoutRoot.Content = DefaultView;
        }
    }
}
